<template>
  <div class="dropdown" :class="{'dropdown--error' : isError}">
    <li @click="toggleMenu()" class="dropdown__toggle" :class="{active : showMenu}" v-if="selectedOption.name !== undefined || label">
      {{ selectedOption.name }}
      <span class="hidden" v-if="label">{{placeholderText}}</span>
      <span class="dropdown__caret" :class="{active : showMenu}"></span>
      <span class="dropdown__label" :class="{active : selectedOption.name}" v-if="label">{{placeholderText}}</span>
    </li>
    <li @click="toggleMenu()" class="dropdown__toggle" :class="{active : showMenu}" v-if="selectedOption.name === undefined && !label">
      {{placeholderText}}
      <span class="dropdown__caret"></span>
    </li>
    <ul class="dropdown__menu" v-if="showMenu">
        <li v-for="option in options" :key="option.name">
            <a href="javascript:void(0)" @click="updateOption(option)">
              {{ option.name }}
            </a>
        </li>
    </ul>
    <div class="dropdown__error">
      <slot></slot>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    value: Object,
    isError: {
      type: Boolean,
      default: false
    },
    options: {
      type: [Array, Object]
    },
    placeholder: [String],
    label: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      selectedOption: {
        name: this.value.name
      },
      showMenu: false,
      placeholderText: 'Please select an item',
    }
  },
  mounted() {
    if (this.placeholder) {
      this.placeholderText = this.placeholder;
    }
  },
  methods: {
    updateOption(option) {
      this.selectedOption = option;
      this.showMenu = false;
      this.$emit('change', this.selectedOption);
    },
    toggleMenu() {
      this.showMenu = !this.showMenu;
    }
  }
}
</script>

<style scoped lang="sass">
.dropdown
  min-width: 3rem
  position: relative
  display: inline-block
  width: 100%
  li
    list-style: none
  &__toggle
    font-family: $mainFont
    font-size: rem(14)
    line-height: 1.4
    color: white
    display: flex
    flex-direction: row
    justify-content: space-between
    align-items: center
    border: none
    cursor: pointer
    position: relative
    &:hover
      background: transparent
    &:after
      content: none
      position: absolute
      bottom: 0
      right: rem(10)
      width: rem(12)
      height: rem(12)
      background-color: $colorSecond
      transform: rotate(45deg) translate(rem(15), rem(15))
    &.active
      &:after
        content: ''
      .dropdown__caret
        transform: rotateZ(-45deg) rotate3d(1, 1, 0, 180deg)
  &__caret
    display: inline-block
    width: rem(8.5)
    height: rem(8.5)
    transform: rotateZ(-45deg)
    border: none
    border-color: white
    border-bottom: solid rem(2)
    border-left: solid rem(2)
    right: rem(5)
    position: relative
    transition: all .3s
    transform-style: preserve-3d
    transform-origin: 25%
  &__label
    position: absolute
    pointer-events: none
    width: auto
    left: rem(16)
    bottom: rem(10)
    text-align: left
    color: $textColorMain
    font-family: $mainFont
    font-size: 1rem
    font-weight: 400
    line-height: 1.5
    transition: transform 0.3s
    transform-origin: left
    &.active
      color: #636e7e
      transform: translate3d(-16px, -150%, 0) scale(0.875)
  &__menu
    position: absolute
    top: 100%
    width: auto
    right: 0
    padding: rem(10)
    z-index: 100
    border-radius: $btnBorderRadius
    box-shadow: 0 12px 18px -3px #60483180
    background-color: $colorSecond
    list-style: none
    font-size: rem(14)
    text-align: left
    background-clip: padding-box
    max-height: rem(101)
    overflow-y: auto
    max-width: 100%
    +media((width: (xs: 100%, md: auto),
    text-align: (xs: center, md: left)))
    &::-webkit-scrollbar
      width: rem(6)
      height: rem(6)
      border-radius: 3px
      background-color: rgba($colorMain, 0.25)
    &::-webkit-scrollbar-track
      opacity: 0
      filter: blur(rem(30))
    &::-webkit-scrollbar-thumb
      border-radius: rem(3)
      background-color: $colorMain
    & > li > a
      font-family: $mainFont
      font-size: rem(15)
      line-height: 1.4
      color: black
      text-decoration: none
      margin: rem(3)
      display: inline-block
  &__error
    display: none
    position: absolute
    bottom: 0
    transform: translateY(100%)
    .error
      font-family: $mainFont
      font-size: rem(12)
      line-height: 1.25
      color: $colorMain
  &--error
    animation-name: shakeError
    animation-fill-mode: forward
    animation-duration: .6s
    animation-timing-function: ease-in-out
    .dropdown
      &__error
        display: block
  &--white
    .dropdown
      &__toggle
        color: black
  &--input
    .dropdown
      &__toggle
        border-radius: 0.375rem
        border: 0.063rem solid #e0e0e0
        background-color: #ffffff
        width: 100%
        padding: 0.625rem 1rem
        color: $textColorMain
        font-family: $mainFont
        font-size: 1rem
        font-weight: 400
        line-height: 1.5
.hidden
  opacity: 0
  pointer-events: none
</style>
